#include "Enemy.h"


#include "Adafruit_GFX.h" // Core graphics library
#include "SPI.h"

#include "Adafruit_Arcada.h"
#include "Adafruit_Arcada_Def.h"
#include "Adafruit_Arcada_Filesystem.h"
#include "arcadatype.h"

#include "EnemyAnim.h"


Enemy::Enemy(int* pos,  int height, int width, int hp, int sp, int lockRDir, int randomWalk, int atkCount, bool startAtk){
    setEnemy(pos, height, width, hp, sp, lockRDir, randomWalk, atkCount, startAtk);
}

void Enemy::setEnemy(int* pos, int height, int width, int hp, int sp, int lockRDir, int randomWalk, int atkCount, bool startAtk){
    
    e_pos = pos;
    e_height = height;
    e_width = width;
    e_hp = hp;
    e_sp = sp;
    e_lockRDir = lockRDir;
    e_randomWalk = randomWalk;
    e_atkCount = atkCount;
    e_startAtk = startAtk;
    
}

void Enemy:: attackP(Player* p, Enemy* e, GFXcanvas16 *canvas){
  int* pos = p -> getPos();
  this -> getEPos();
  
  if(collideToP( pos[0] , pos[1], (this -> getEPos())[0], (this -> getEPos())[1], 8, 8)){
    this -> setStartAtk(true);
  }
  
  if( (this -> getStartAtk()) ){
    
    
    if( (this -> getAtkCount()) >10 && (this -> getAtkCount()) <20){ //load atk
      canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], EattackLoad, E_mask, 16, 16);
    }
    
    
    if( (this -> getAtkCount()) == 19 ){ //do atk
      
      canvas->drawRGBBitmap((this -> getEPos())[0]-4, (this -> getEPos())[1]-4, Eattack, 24, 24);
      
      if(collideToP( pos[0] , pos[1], (this -> getEPos())[0], (this -> getEPos())[1], 8, 12)){ //lose hp when in range        
          canvas-> fillCircle(pos[0]+8, pos[1]+8, 8, ARCADA_RED); 
          p -> setHP(1);
      
      }
      
      this -> setStartAtk(false);
    }
    this -> setAtkCount(1);
      
  }
  
}

void Enemy:: moveE(Player* p, Enemy* e, GFXcanvas16 *canvas){
  

  if((this -> getEHp()) > 0){
    
    switch( (this->getEDirec()) ){ //direction when not moving
    case 0:
      canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1R, E_mask, 16, 16);
      break;
    case 1:
      canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1L, E_mask, 16, 16);
      break;
    case 2:
      canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1D, E_mask, 16, 16);
      break;
    case 3:
      canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1U, E_mask, 16, 16);
      break;
    
  }
    
    
    if( !collideToP( (p->getPos())[0], (p->getPos())[1], (this -> getEPos())[0], (this -> getEPos())[1], 8, 8) ){ // no collision -> move
      if( (this -> getESp()) ==1){ //speed 
    
        if( (this->getERandomWalk()) < 10){ //10 steps to MC
          if((p->getPos())[0] < (this -> getEPos())[0]){
            this ->setEDirec(1);
            (this -> getEPos())[0] = (this -> getEPos())[0]-1;
          }
          if((p->getPos())[0] > (this -> getEPos())[0]){
            this ->setEDirec(0);
            (this -> getEPos())[0] = (this -> getEPos())[0]+1;
          }
          if((p->getPos())[1] < (this -> getEPos())[1]){
            this ->setEDirec(3);
            (this -> getEPos())[1] = (this -> getEPos())[1]-1;
          }
          if((p->getPos())[1] > (this -> getEPos())[1]){
            this ->setEDirec(2);
            (this -> getEPos())[1] = (this -> getEPos())[1]+1;
          }
        }
      
        if( (this->getERandomWalk()) >=10 && (this->getERandomWalk()) <20){ //10 steps random
          
          if( (this -> getELockRDir()) == 0){ // lock random generated number
            this -> setERandomDir(random(4));
          }
           
          switch( (this -> getERandomDir()) ){ // enemy walks
            case 0:
              (this -> getEPos())[0] = (this -> getEPos())[0]+1; 
              canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1R, E_mask, 16, 16);
              break;
            case 1:
              (this -> getEPos())[0] = (this -> getEPos())[0]-1;
              canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1L, E_mask, 16, 16);
              break;
            case 2:
              (this -> getEPos())[1] = (this -> getEPos())[1]-1;
              canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1D, E_mask, 16, 16);
              break;
            case 3:
              (this -> getEPos())[1] = (this -> getEPos())[1]+1;
              canvas->drawRGBBitmap((this -> getEPos())[0], (this -> getEPos())[1], E1U, E_mask, 16, 16);
              break;
          }
          this -> setELockRDir(1);
          
        }
        
        
      this->setERandomWalk(1);    
      setESp(0);
      }
      else { setESp(1); }
      
    }
    attackP(p, e, canvas);
  }

      
}



bool Enemy:: collideToP(int pX, int pY, int eX, int eY, int pR, int eR){
  double dx = pX - eX;
  double dy = pY - eY;
  double dist = sqrt(dx*dx+dy*dy);


  if(dist < (pR+eR)){
    //collision
    return true; 
  }
  else{
    return false;
  }
}
