#ifndef ENEMY_H
#define ENEMY_H

#include "Player.h" 


#include "Adafruit_GFX.h" // Core graphics library
#include "SPI.h"

#include "Adafruit_Arcada.h"
#include "Adafruit_Arcada_Def.h"
#include "Adafruit_Arcada_Filesystem.h"
#include "arcadatype.h"

class Player;
class Enemy{
    

    private:
        int* e_pos;
        int e_height, e_width; 
        int e_hp;

        //walk variables
        int e_sp; //speed
        int e_randomDir; //direction // 0 right, 1 left, 2 down, 3 up
        int e_Direc;
        int e_lockRDir; //10 reset
        int e_randomWalk; //steps
        
        //atk variables
        int e_atkCount;
        bool e_startAtk;
        

    public:
        Enemy(int* pos,  int height, int width, int hp, int sp, int lockRDir, int randomWalk, int atkCount, bool startAtk);
        ~Enemy();

        void setEnemy(int* pos, int height, int width, int hp, int sp, int lockRDir, int randomWalk, int atkCount, bool startAtk);

        
        int* getEPos(){return e_pos;}
        int getEHeight(){return e_height;}
        int getEWidth(){return e_width;}
        int getEHp(){return e_hp;}

        //walk variables
        int getESp(){return e_sp;} //speed
        int getERandomDir(){return e_randomDir;}
        int getEDirec(){return e_Direc;}
        int getELockRDir(){return e_lockRDir;}
        int getERandomWalk(){return e_randomWalk;} 
        
        //atk variables
        int getAtkCount(){return e_atkCount;}
        bool getStartAtk(){return e_startAtk;}
        
        
        void setEHp(int dmg){ e_hp = e_hp-dmg; }
        
        //walk variables
        void setESp(int x){ e_sp = x; } //speed 0 or 1
        void setERandomDir(int x){ e_randomDir = x; } //random(4)
        void setEDirec(int x){e_Direc = x; } //0-3
        void setELockRDir(int x){ //0-10, 10 reset
          e_lockRDir = e_lockRDir+x;
          if(e_lockRDir == 10){
            e_lockRDir = 0;
          }
        }
        void setERandomWalk(int x){ //0-20, 20 reset
          e_randomWalk = e_randomWalk+x;
          if(e_randomWalk == 20){
            e_randomWalk = 0;
          }
        } 
        
        //atk variables
        void setAtkCount(int x){
          e_atkCount = e_atkCount+x;
          if(e_atkCount == 20){
            e_atkCount = 0;
          }
        }
        void setStartAtk(bool value){
          e_startAtk = value;
        }
        

        void moveE(Player* p, Enemy* e, GFXcanvas16* canvas);        
        void attackP(Player* p, Enemy* e, GFXcanvas16 *canvas);

        //R is radius, p player, e enemy, X,Y coordinates
        bool collideToP(int pX, int pY, int eX, int eY, int pR, int eR);
};


#endif
