#include "Player.h"

#include "Adafruit_GFX.h" // Core graphics library
#include "SPI.h"

#include "Adafruit_Arcada.h"
#include "Adafruit_Arcada_Def.h"
#include "Adafruit_Arcada_Filesystem.h"
#include "arcadatype.h"
#include "MCmovement.h"

int direc = 0; // 0 right, 1 left, 2 down, 3 up
int walk = 0;

Player::Player(int* pos,  int height, int width, int hp){
    setPlayer(pos, height, width, hp);
}

void Player::setPlayer(int* pos, int height, int width, int hp){
    m_pos = pos;
    m_height = height;
    m_width = width;
    m_hp = hp;

}



void Player:: attackE(Adafruit_Arcada arcada, uint8_t b, Player* p, Enemy* e, GFXcanvas16 *canvas) //attack enemies
{
int* pos = this -> getPos();
int* e_pos = e -> getEPos();
  if (b & ARCADA_BUTTONMASK_A){
    switch(direc){ // animation
        case 0:
            canvas->drawRGBBitmap(pos[0]+1, pos[1]-4, McHitRight2, hR2mask, 20, 20);
            
          if(collide( (pos[0]+2) , pos[1], e_pos[0], e_pos[1], 8, 8)) {
            if( (e->getEHp())>0){
              e -> setEHp(1);
              canvas-> fillCircle(e_pos[0]+8, e_pos[1]+8, 8, ARCADA_RED);  
            }
          }
          break;
        case 1:
            canvas->drawRGBBitmap(pos[0]-5, pos[1]-4, McHitLeft2, hL2mask,20, 20);
            
          if(collide( (pos[0]-2) , pos[1], e_pos[0], e_pos[1], 8, 8)) {
            if( (e->getEHp())>0){
              e -> setEHp(1);
              canvas-> fillCircle(e_pos[0]+8, e_pos[1]+8, 8, ARCADA_RED);  
            }
          }
          break;
        case 2:
            canvas->drawRGBBitmap(pos[0]-2, pos[1], McHitDown2, hD2mask, 20, 20);
            
          if(collide( pos[0] , (pos[1]+2), e_pos[0], e_pos[1], 8, 8)) {
            if( (e->getEHp())>0){
              e -> setEHp(1);
              canvas-> fillCircle(e_pos[0]+8, e_pos[1]+8, 8, ARCADA_RED);  
            }
          }
          break;
        case 3:
            canvas->drawRGBBitmap(pos[0]-2, pos[1]-4, McHitUp2, hU2mask,20, 20);
            
          if(collide( (pos[0]+2) , (pos[1]-2), e_pos[0], e_pos[1], 8, 8)) {
            if( (e->getEHp())>0){
              e -> setEHp(1);
              canvas-> fillCircle(e_pos[0]+8, e_pos[1]+8, 8, ARCADA_RED);  
            }
          }
          break;        
    } 
  }      
}




int* Player:: moveP(Adafruit_Arcada arcada, uint8_t b, Player* p, int objPos[][2], GFXcanvas16 *canvas) //movement, direction, animation, bounds, collision of MC
{
  int* pos = this -> getPos();
  
  
    
    switch(direc){ //direction when not moving
      case 0:
        canvas->drawRGBBitmap(pos[0], pos[1], MCstandR, sRmask, 16, 16);
        break;
      case 1:
        canvas->drawRGBBitmap(pos[0], pos[1], MCstandL, sLmask, 16, 16);
        break;
      case 2:
        canvas->drawRGBBitmap(pos[0], pos[1], MCstandD, sDmask, 16, 16);
        break;
      case 3:
        canvas->drawRGBBitmap(pos[0], pos[1], MCstandU, sUmask, 16, 16);
        break;
    }
    
    
      if (b & ARCADA_BUTTONMASK_RIGHT)
      {
        direc=0;
        
        if(walk<=5){ //walking animation right
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveR1, mR1mask, 16, 16);
          walk++;
        }
        else{
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveR2, mR2mask, 16, 16);
          walk++;
          if(walk==10){
            walk=0;
          }
        }
        
          pos[0] = pos[0] + 1;
          
          for(int i=0; i< 3; i++){ //collide with objects, blocking way
           
           if(collide(pos[0], pos[1], objPos[i][0], objPos[i][1], 8, 8) ){
            
              pos[0] = objPos[i][0]-16;
            } 
          }
          if (pos[0] >= (156 - m_width))
          {
              pos[0] = 156 - m_width;
          }
          
      }
      
      if (b & ARCADA_BUTTONMASK_LEFT)
      {
        direc=1;
        
        if(walk<=5){ //walking animation left
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveL1, mL1mask, 16, 16);
          walk++;
        }
        else{
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveL2, mL2mask, 16, 16);
          walk++;
          if(walk==10){
            walk=0;
          }
        }
        
          pos[0] = pos[0] - 1;
  
          for(int i=0; i< 3; i++){
           
           if(collide(pos[0], pos[1], objPos[i][0], objPos[i][1], 8, 8) ){
            
              pos[0] = objPos[i][0]+16;
            } 
          }
          
          if (pos[0] <= 4)
          { // 0 left bound
              pos[0] = 4;
          }
      }
      if (b & ARCADA_BUTTONMASK_DOWN)
      {
        direc=2;
        
        if(walk<=5){ //walking animation down
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveD1, mD1mask, 16, 16);
          walk++;
        }
        else{
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveD2, mD2mask, 16, 16);
          walk++;
          if(walk==10){
            walk=0;
          }
        }
        
          pos[1] = pos[1] + 1;
  
          for(int i=0; i< 3; i++){
           
           if(collide(pos[0], pos[1], objPos[i][0], objPos[i][1], 8, 8) ){
            
              pos[1] = objPos[i][1]-16;
            } 
          }
          
          if (pos[1] >= (124-m_height))
          { // lower bound
              pos[1] = 124-m_height;
          }
      }
      if (b & ARCADA_BUTTONMASK_UP)
      {
        direc=3;
        
        if(walk<=5){ //walking animation up
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveU1, mU1mask, 16, 16);
          walk++;
        }
        else{
          canvas->drawRGBBitmap(pos[0], pos[1], MCmoveU2, mU2mask, 16, 16);
          walk++;
          if(walk==10){
            walk=0;
          }
        }
        
          pos[1] = pos[1] - 1;
          
          for(int i=0; i< 3; i++){
           
           if(collide(pos[0], pos[1], objPos[i][0], objPos[i][1], 8, 8) ){
            
              pos[1] = objPos[i][1]+16;
            } 
          }
          
          if (pos[1] <= 4)
          { // upper bound
              pos[1] = 4;
          }
      }
  
  return pos;
}

bool Player:: collide(int pX, int pY, int oX, int oY, int pR, int oR){
  double dx = pX - oX;
  double dy = pY - oY;
  double dist = sqrt(dx*dx+dy*dy);


  if(dist < (pR+oR)){
    //collision
    return true; 
  }
  else{
    return false;
  }
}
