#ifndef PLAYER_H
#define PLAYER_H

#include "Enemy.h"

#include "Adafruit_GFX.h" // Core graphics library
#include "SPI.h"

#include "Adafruit_Arcada.h"
#include "Adafruit_Arcada_Def.h"
#include "Adafruit_Arcada_Filesystem.h"
#include "arcadatype.h"

class Enemy;
class Player{
    
    private:
        int* m_pos;
        int m_height, m_width;
        int m_hp;
    
    public:
        Player(int* pos, int height, int width, int hp);
        ~Player();

        void setPlayer(int* pos, int height, int width, int hp);

        void setHP(int dmg){ 
          m_hp = m_hp - dmg;
          if (m_hp <= -1){
            m_hp = -1;
          }
        }
        
        int* getPos(){return m_pos;}
       
        int getHeight(){return m_height;}
        int getWidth(){return m_width;}
        int getHp(){return m_hp;}

        int* moveP( Adafruit_Arcada arcada, uint8_t b, Player* p, int obj[][2], GFXcanvas16 *canvas);

        //o for objects, R radius, p player, e enemy, X,Y coordinates
        bool collide(int pX, int pY, int oX, int oY, int pR, int oR);
        void attackE(Adafruit_Arcada arcada, uint8_t b, Player* p, Enemy* e, GFXcanvas16 *canvas);


};

#endif
